# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

def install():
    run_notfatal('apt-get remove inkscape -y')
    if isdir('/opt/inkscape'):
        remove_tree('/opt/inkscape')
    mkdirs('/opt/inkscape')
    filecopyto(glob.glob('*.AppImage')[0],'/opt/inkscape/inkscape.AppImage')
    filecopyto('WAPT/icon.png','/opt/inkscape/icon.png')

    filecopyto('inkscape.desktop','/usr/share/applications/inkscape.desktop')
    run('chown root:root /usr/share/applications/inkscape.desktop')
    run('ln -sf /opt/inkscape/inkscape.AppImage /usr/bin/inkscape')
    run('chmod a+x /opt/inkscape/inkscape.AppImage')



def uninstall():
    run('unlink /usr/bin/inkscape')
    remove_tree('/opt/inkscape')
    remove_file('/usr/share/applications/inkscape.desktop')

def update_package():
    import requests
    import re
    print('Download/Update package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Specific app values
    app_name = control.name
    url = 'https://inkscape.org/release/?latest=1'

    # Getting latest version from official website
    version = re.findall('<title>Download Inkscape (.*) \| Inkscape</title>',ensure_unicode(wgets(url)))[0]
    url_dl = 'https://inkscape.org/release/inkscape-%s/gnulinux/appimage/dl/' % version
    url_dl = 'https://inkscape.org/' +  re.findall('<p>Your download should start in 2 seconds, if not, please <a href="(.*)">click here',ensure_unicode(wgets(url_dl)))[0]
    newfilename = url_dl.split('/')[-1]

    print('Latest ' + newfilename + ' version is: ' + version)
    print('Download url is: ' + url_dl)

    control.version = '%s-%s'%(version,int(control.version.split('-',1)[1])+1)
    control.save_control_to_wapt()
 
    # Downloading latest binaries
    if not isfile(newfilename):
        wget(url_dl,newfilename,proxies=proxy)
    else:
        print('This package is already up-to-date')

    # Deleting outdated binaries
    for bin_in_dir in glob.glob('*.AppImage'):
        if bin_in_dir != newfilename :
            print('Outdated binary: ' + bin_in_dir + ' Deleted')
            remove_file(bin_in_dir)
